@cT datastream 1
$syntaxlevel 2

* A program that plots a function of x and y
* using a set of icons of differing dot densities.

define	f: haltflag
	m: lastfunction
	user:
	f: x, y
	
fine	500,300
icons	"random"  $$ randomly-placed dots in 8*8 icons, 0 through 64

menu	Stop Plotting: Halt
calc	lastfunction := "30abs(xy)(x^2+y^2)exp[-sqrt(x^2+y^2)]"

unit	XYplotter
	merge,global:
	i: ICONW=8  $$ width of the random icons
	f: AXESXMAX=30ICONW, AXESYMAX=15ICONW
	f: XMAX=10, YMAX=XMAX*AXESYMAX/AXESXMAX
	f: DX=XMAX*ICONW/AXESXMAX, DY=YMAX*ICONW/AXESYMAX
	i: z
	i: jitter
next	XYplotter
gorigin	250,AXESYMAX+10
axes	- AXESXMAX,- AXESYMAX;  AXESXMAX, AXESYMAX
scalex	XMAX
scaley	YMAX
labelx	2,1
labely	1, .5
arrow	50,2AXESYMAX+20
	calc	zarrowm := zcopy(lastfunction)
calc	lastfunction := zcopy(zarrowm)
	haltflag := FALSE
at	60,2AXESYMAX+40
compute	z
no	zreturn
	loop	y := YMAX,-YMAX,-DY
		loop	x := -XMAX, XMAX, DX
	outloop	haltflag
			compute	z
			if	~zreturn
				do	ShowError
	outloop
			endif
			if	z >= 64
				calc	z := 64
			elseif	z <= 0
				calc	z := 0
			else
				randu	jitter,3
				calc	z := z+jitter-2
			endif
			gat	x,y
			plot	z
		endloop
	endloop
	specs	nookno
	judge	ok
do	ShowError
endarrow
text	zxmin,zymax-20; zxmax,zymax
@1ff   2@1pl4004Press Return  @1ff8000
@1pl8000\

unit	ShowError@1ff   0
@1pl4006write	\zreturn
	\
	\zopcnt > 0 with -specs noops- in effect
	\illegal character
	\decimal point error (such as 3...5)
	\currently unused
	\currently unused
	\error in form (such as 34+)
	\missing left parenthesis
	\unrecognized variable name
	\illegal function argument (such as sqrt -1))
	\missing right parenthesis
	\zvarcnt > 0 with -specs novars- in effect..
	\invalid assignment (:=)   @1ff8000
@1pl8000
unit	Halt
calc	haltflag := TRUE
@cT end
